/*
** static_assert.h - written in milano by vesely on 05 Mar 2019
** clamav interface for courier-mta global filters
**
** This file is part of avfilter
**
** Copyright (c) 2019 Alessandro Vesely
** All rights reserved. see COPYING
*/
#if ! defined STATIC_ASSERT_H_INCLUDED

// assert.h may define static_assert _Static_assert with
// varying syntax depending on compiler version

#if defined static_assert
#undef static_assert
#endif

#if defined __GNUC__
#define STATIC_ASSERT_UNUSED __attribute__((unused))
#else
#define STATIC_ASSERT_UNUSED
#endif

#define STATIC_ASSERT_NAME(x) STATIC_ASSERT_NAME2(x)
#define STATIC_ASSERT_NAME2(x) STATIC_ASSERT_AT_ ## x

#define static_assert(x) \
	typedef char STATIC_ASSERT_NAME(__LINE__) [(x)? 1: -1] STATIC_ASSERT_UNUSED

#define STATIC_ASSERT_H_INCLUDED
#endif
